<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\DataTables\ImpostazioniDataTable;
use App\Models\Impostazioni;
use Illuminate\Support\Facades\Session;

class ImpostazioniController extends Controller
{
    public static $permission_group = "Impostazioni";
    public static $permissions = [
        'view-impostazioni' => 'Vedi',
        'create-impostazioni' => 'Crea',
        'edit-impostazioni' => 'Modifica',
        'delete-impostazioni' => 'Elimina',
    ];
    
    public static function middleware(): array
    {
        return [
            new Middleware('permission:view-impostazioni', only: ['index']),
            new Middleware('permission:create-impostazioni|edit-impostazioni|delete-impostazioni', only: ['store']),
        ];
    }
    
    public function index(ImpostazioniDataTable $dataTable)
    {
        $dataTable->attivita_id = Session::get('attivita_attuale');
        return $dataTable->render('impostazioni.index');
    }

    public function store(ImpostazioniDataTableEditor $editor)
    {
        $request = request();
        $input = $request->all();
        if($request->has('action')){
            switch($input['action']){
                case 'create':
                    if(!Auth::user()->can('create-impostazioni')) return;
                    break;
                case 'edit':
                    if(!Auth::user()->can('edit-impostazioni')) return;
                    break;
                case 'delete':
                    if(!Auth::user()->can('delete-impostazioni')) return;
                    break;
            }
        }
        return $editor->process($request);
    }
}
